//     Author: Maurizio Loreti, aka MLO or (HAM) I3NOO
//     Work:   University of Padova - Department of Physics
//             Via F. Marzolo, 8 - 35131 PADOVA - Italy
//     Phone:  +39 (049) 827-7216   FAX: +39 (049) 827-7102
//     EMail:  loreti@pd.infn.it
//     WWW:    http://www.pd.infn.it/~loreti/mlo.html
//
// -------------------------------------------------------------------
// Test program for conf.hh/conf.cxx .
//
// $Id: testConf.cxx,v 1.3 2006/06/20 08:48:49 loreti Exp $
//
// -------------------------------------------------------------------

#include "conf.hh"

using std::cerr;
using std::cout;
using std::endl;
using std::string;

int main() {
  int           iv[2] = {-1, -2};
  unsigned int  uv[3] = {4, 5, 6};
  long          l     = 123;
  short         ll    = 234;
  int           la[5] = {1, 2, 3, 4, 5};
  unsigned long ul    = 345;
  float         d     = 6.28;
  double        da[5] = {1.23, 2.34, 3.45, 4.56, 5.67};
  string        s     = "String";
  string        sa[3] = {"String 1", "String 2", "String 3"};
  string        sb[3] = {"String 1", "String 2", "String 3"};

  const string fileName("conf.txt");
  std::ifstream ifile(fileName.c_str());

  setupMaster sm;
  CONFVAR(sm, l);
  CONFVAR(sm, ll);
  CONFVAR(sm, ul);
  CONFVAR(sm, s);
  CONFVAR(sm, d);
  CONFARRAY(sm, da);
  CONFARRAY(sm, la);
  CONFARRAY(sm, sa);
  CONFARRAY(sm, sb);
  CONFARRAY(sm, iv);
  CONFARRAY(sm, uv);
  CONFVAR(sm, d);

  cout << "\n  Initial content:\n" << sm << endl;

  if (!ifile) {
    cerr << "*** Couldn't open file \"" << fileName << "\"\n";
  } else {
    cout << "    Reading \"" << fileName << "\" ..." << endl;
    sm.readFile(&ifile, fileName);
    ifile.close();
    cout << "    ... done.\n\n  Final content:\n" << sm;
  }
  return 0;
}
