/* $Id: testConfig.c,v 1.5 2000/06/27 12:21:53 loreti Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"

#define STR_LEN         64
#define TEST_FILE       "config.txt"

static void testRet(int, const char *);

int main()
{
  int i, ival[2] = {-1,-2};
  unsigned int uival[3] = {4,5,6};
  long l, ll, l0=42, la[5], ld[5]={1,2,3,4,5};
  unsigned long ul;
  double d, da[5];
  char s1[STR_LEN], s2[STR_LEN];
  char sa1[STR_LEN], sa2[STR_LEN], sa3[STR_LEN];
  char sb1[STR_LEN], sb2[STR_LEN], sb3[STR_LEN];
  FILE *fp;

/* Initialisation of some targets */

  memcpy(&ll, &l0, sizeof(l0));
  strcpy(s1, "Default string 1");
  strcpy(s2, "Default string 2");
  memcpy(la, ld, sizeof(ld));
  strcpy(sa1, "Substring 1");
  strcpy(sa2, "Substring 2");
  strcpy(sa3, "Substring 3");
  strcpy(sb1, "Substring 1");
  strcpy(sb2, "Substring 2");
  strcpy(sb3, "Substring 3");

  addConfig(1, 32767,           "l",     0, &l);
  addConfig(1, CONFIG_LONG,     "l",     0, &l);
  addConfig(1, CONFIG_LONG,     "ll",    1, &ll);
  addConfig(1, CONFIG_ULONG,    "ul",    1, &ul);
  addConfig(1, CONFIG_DOUBLE,   "d",     1, &d);
  addConfig(1, CONFIG_STRING,   "s1",    1, s1);
  addConfig(1, CONFIG_STRING,   "s2",    1, s2);
  addConfig(1, CONFIG_DOUBLE,   "da",    5, da);
  addConfig(1, CONFIG_LONG,     "la",    5, la);
  addConfig(1, CONFIG_STRARRAY, "sa",    3, sa1, sa2, sa3);
  addConfig(1, CONFIG_STRARRAY, "sb",    3, sb1, sb2, sb3);
  addConfig(1, CONFIG_INT,      "ival",  2, ival);
  addConfig(1, CONFIG_UINT,     "uival", 3, uival);

  if ((fp = fopen(TEST_FILE, "r")) == 0) {
    puts("Couldn't open test file");
    return EXIT_FAILURE;
  }

  testRet(readConfig(1, fp, TEST_FILE), "readConfig");
  fclose(fp);
  testRet(remConfig(1), "remConfig");

  printf("- ll    = %ld (default)\n- s2    = \"%s\" (default)\n", ll, s2);
  printf("- l     = %ld\n- ul    = %lu\n", l, ul);
  printf("- d     = %f\n- s1    = \"%s\"\n", d, s1);
  printf("- da    =");
  for (i=0; i<5; i++) printf(" %f", da[i]);
  printf("\n- la    =");
  for (i=0; i<5; i++) printf(" %ld", la[i]);
  puts(" (last two values are the default)");
  printf("- sa[1] = \"%s\"\n", sa1);
  printf("- sa[2] = \"%s\"\n", sa2);
  printf("- sa[3] = \"%s\"\n", sa3);
  printf("- sb[1] = \"%s\"\n", sb1);
  printf("- sb[2] = \"%s\"\n", sb2);
  printf("- sb[3] = \"%s\" (the default)\n", sb3);
  printf("- ival  = %d %d\n", ival[0], ival[1]);
  printf("- uival = %u %u %u\n", uival[0], uival[1], uival[2]);

  return EXIT_SUCCESS;
}

static void testRet(
  int retVal,
  const char *name
) {
  printf("(\"%s\" returned ", name);
  switch (retVal) {
    case CONFIG_ERROR: puts("CONFIG_ERROR)");     break;
    case CONFIG_OK:    puts("CONFIG_OK)");        break;
    default:           puts("an invalid value)"); break;
  }
}
